# Kitchen Hazard Warning System


Simple Kitchen Hazard Warning System. Detecting CO and LPG level in the area using MQ-9 sensor with buzzer, LED alarm, E-mail Notification, Web-monitoring interface and API.

## API Endpoint

- /get_from_date

  Description:
    
    Get gas reading from the specified date.
    
  query param:

    - date

       YYYY-MM-DD date format
 
     
- /get_last_data

  Description:
  
    Get last available gas reading.
    
- /time_when_gas_equal

  Description:
    Get data when gas level is equal to specified level
    
   query param:
   
    - level (integer range from 0-4)
    
- /set_alarm_state
 
   Description:
    Set global alarm level overiding gas reading alarm. (LED of current the gas alarm level will still on).
    
   query param:
   
    - state (integer range from 0-2)

- /get_alarm_state

  Description:
    Get current global alarm level.

## File Description

- control/usbctrl.py

  Microcontroller USB Serial Interface Module.
  
- control/core.py

  Microcontroller core task Module
  
- db

  store sqlite3 database file.

- firmware/source

  Contain project's firmware source and compiled binary.
 
- static

  Contain javascript and css libralies.
  
- templates

  Contain static HTML files in jinja2 format for FastApi htmlrender response.
  
- db.py

  Project's sqlite3 database interface module.
  
- example_hardware_run.py

  Project's example hardware usage, automatic polling to database with configurable interval.
  
- mailer.py

  Project's service email management module.
  
- notifier.py

  Project's email notifier service module.
  
- main.py

  Project's web-application service with FastApi framework.
  
- requirements.txt

  Project's python pip requirement file.
  
- env

  python virtualenv folder.
  

## License

See [LICENSE](LICENSE.txt)

## Dependecy
According to [requirements.txt](requirements.txt)
(Require python 3.6.x or above)
Python Library
```
pyusb
fastapi>=0.52.0
uvicorn>=0.11.3
ujson
email_validator
jinja2
aiofiles
python-multipart
numpy
sqlalchemy
yagmail[all]
```

## Hardware

- MQ-9 Carbon Monixide and Flammable gas sensor.
- 3-5V Buzzer Alarm.
- 10mm Three color LED Module.
- 0.9" OLED Display


## Author

Amrest Chinkamol 6110503517
Chaiviwat Cheunchart 6110503223

Department of Computer Engineering. Faculty of Engineering. Kasetsart University.
