import sqlite3 as lite
import sys

class Database():

    DBFILE = './db/sensorData.db'

    def connect(self):
        return lite.connect(self.DBFILE)

    def create(self):
        con = self.connect()
        def create_db():
            with con:
                cur = con.cursor()
                # cur.execute("DROP TABLE IF EXISTS SensorData")
                cur.execute("CREATE TABLE IF NOT EXISTS SensorData(timestamp DATATIME, RAW NUMERIC, CO_LPG NUMERIC)")
            print("TABLE CREATED")
        create_db()
        con.close()

    def insert(self, RAW_value, CO_LPG_value):
        con = self.connect()
        with con:
            cur = con.cursor()
            cur.execute(f"INSERT INTO SensorData VALUES(datetime('now'), {RAW_value}, {CO_LPG_value})")
        con.commit()
        con.close()

    def print_log(self):
        con = self.connect()
        with con:
            cur = con.cursor()
            for row in cur.execute("SELECT * FROM SensorData"):
                print(row)
        con.close()

    def query(self, SEL="*", COMD = ""):
        data = []
        con = self.connect()
        with con:
            cur = con.cursor()
            for row in cur.execute(f"SELECT {SEL} FROM SensorData {COMD}"):
                time = row[0]
                raw = row[1]
                concen = row[2]
                dict_val = {"time": time, "raw_reading": raw, "Concentration_level": concen}
                data.append(dict_val)
        return data
    
    def query_noformat(self, SEL="*", COMD=""):
        data = []
        con = self.connect()
        with con:
            cur = con.cursor()
            for row in cur.execute(f"SELECT {SEL} FROM SensorData {COMD}"):
                data.append(row)
        return data