import threading
import time
from mailer import Mailservice
from control.usbctrl import Control
from db import Database

MailServ = Mailservice()
Device = Control()

mails_to_notify = ['amrest.c@ku.th',
                  # 'chaiviwat.ch@ku.th'
                  ]

class Notifier:

    db = Database()

    def __init__(self, device: Control = Control(), interval=60):

        self.device = Control()
        self.update = True
        self.interval = interval
        self.thread_start = False

    def start_watchout(self, silent: bool = True):
        self.thread_start = True
        if silent: print("Silent Run")
        thread = threading.Thread(target=self.get_update_from_device, args=([silent]))
        thread.daemon = True
        thread.start()

    def stop_watchout(self):
        self.update = False
        self.thread_start = False

    def get_update_from_device(self, silent):
        self.update = True
        while self.update:
            alarm_state = self.device.get_alarm()
            if alarm_state > 0:
                for mail in mails_to_notify:
                    MailServ.send_email(to=mail, subject="ALARM SYSTEM NOTIFY", content=f"ALERT LEVEL: {alarm_state}")
            time.sleep(self.interval)
        print("Stop Updating")
        return 0

if '__main__' == __name__:
    Noti = Notifier()
    Noti.start_watchout()
    while True:
        try:
            pass
        except KeyboardInterrupt:
            Noti.stop_watchout()